Package: uaparserjs
Type: Package
Title: Parse 'User-Agent' Strings
Version: 0.3.8
Date: 2026-05-09
Authors@R: c(
    person("Bob", "Rudis", , "bob@rud.is", role = c("aut", "cph")),
    person("Greg", "Hunt", , "greg@firmansyah.com", role = c("aut", "cre", "cph")),
    person("Lindsey", "Simon", role = "aut", comment = "uap-core"),
    person("Tobie", "Langel", role = "aut", comment = "uap-core"),
    person("Colman", "Humphrey", role = "ctb"))
Description: Despite there being a section in RFC 7231
    <https://datatracker.ietf.org/doc/html/rfc7231#section-5.5.3> defining a suggested
    structure for 'User-Agent' headers this data is notoriously difficult
    to parse consistently. Tools are provided that will take in user agent
    strings and return structured R objects. This is a 'V8'-backed package
    based on the 'ua-parser' project <https://github.com/ua-parser>.
URL: https://github.com/gregfrog/uaparserjs
BugReports: https://github.com/gregfrog/uaparserjs/issues
License: Apache License 2.0 | file LICENSE
Suggests: tinytest, yaml
Depends: R (>= 3.5.0)
Encoding: UTF-8
Imports: progress, V8
RoxygenNote: 7.3.2
NeedsCompilation: no
Packaged: 2026-05-09 06:49:49 UTC; greg
Author: Bob Rudis [aut, cph],
  Greg Hunt [aut, cre, cph],
  Lindsey Simon [aut] (uap-core),
  Tobie Langel [aut] (uap-core),
  Colman Humphrey [ctb]
Maintainer: Greg Hunt <greg@firmansyah.com>
Repository: CRAN
Date/Publication: 2026-05-09 14:40:12 UTC
Built: R 4.6.0; ; 2026-05-09 17:51:16 UTC; unix

Package: uaparserjs
Type: Package
Title: Parse 'User-Agent' Strings
Version: 0.4.0
Date: 2026-07-02
Authors@R: c(
    person("Bob", "Rudis", , "bob@rud.is", role = c("aut", "cph")),
    person("Greg", "Hunt", , "greg@firmansyah.com", role = c("aut", "cre", "cph")),
    person("Lindsey", "Simon", role = "aut", comment = "uap-core"),
    person("Tobie", "Langel", role = "aut", comment = "uap-core"),
    person("Colman", "Humphrey", role = "ctb"),
    person("Jim", "Vine", role = "ctb"))
Description: 
    Parses HTTP user agent strings and returns user agent, device and OS information.  This is a 'V8'-backed package
    based on the 'ua-parser' project <https://github.com/ua-parser>.
URL: https://github.com/gregfrog/uaparserjs
BugReports: https://github.com/gregfrog/uaparserjs/issues
License: Apache License 2.0 | file LICENSE
Suggests: tinytest, yaml, tibble
Depends: R (>= 3.5.0)
Encoding: UTF-8
Imports: progress, V8
NeedsCompilation: no
Packaged: 2026-07-01 22:19:07 UTC; greg
Author: Bob Rudis [aut, cph],
  Greg Hunt [aut, cre, cph],
  Lindsey Simon [aut] (uap-core),
  Tobie Langel [aut] (uap-core),
  Colman Humphrey [ctb],
  Jim Vine [ctb]
Maintainer: Greg Hunt <greg@firmansyah.com>
Repository: CRAN
Date/Publication: 2026-07-02 21:50:02 UTC
Built: R 4.6.1; ; 2026-07-02 22:40:42 UTC; unix

![License](https://img.shields.io/badge/License-Apache-blue.svg)

# uaparserjs

Parse ‘User-Agent’ Strings

## Description

Parses HTTP user agent strings and returns user agent, device and OS information.  This is a 'V8'-backed package
based on the 'ua-parser' project <https://github.com/ua-parser>.

## What’s Inside The Tin

The following functions are implemented:

  - `ua_parse`: Parse a vector of user agents into a data frame

## Installation

``` r
install.packages("uaparserjs")
```

### Usage

``` r
library(uaparserjs)

# current version
packageVersion("uaparserjs")
## [1] '0.3.5'

dplyr::glimpse(ua_parse("Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.2 (KHTML, like Gecko) Ubuntu/11.10 Chromium/15.0.874.106 Chrome/15.0.874.106 Safari/535.2"))
## Rows: 1
## Columns: 9
## $ userAgent     <chr> "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.2 (KHTML, like Gecko) Ubuntu/11.10 Chromium/15…
## $ ua.family     <chr> "Chromium"
## $ ua.major      <chr> "15"
## $ ua.minor      <chr> "0"
## $ ua.patch      <chr> "874"
## $ os.family     <chr> "Ubuntu"
## $ os.major      <chr> "11"
## $ os.minor      <chr> "10"
## $ device.family <chr> "Other"

agents <- readLines(system.file("extdat", "agents.txt", package = "uaparserjs"))

dplyr::glimpse(ua_parse(agents))
## Rows: 1,091
## Columns: 13
## $ userAgent     <chr> "Mozilla/5.0 (Windows; U; en-US) AppleWebKit/531.9 (KHTML, like Gecko) AdobeAIR/2.5.1", "Mozill…
## $ ua.family     <chr> "AdobeAIR", "Amazon Silk", "Amazon Silk", "Amazon Silk", "Amazon Silk", "Amazon Silk", "Android…
## $ ua.major      <chr> "2", "1", "2", "2", "2", "3", "2", "2", "2", "2", "3", "4", "4", "4", "4", "1", "1", "6", "7", …
## $ ua.minor      <chr> "5", "1", "0", "1", "2", "25", "2", "3", "3", "3", "0", "0", "0", "0", "0", NA, NA, "13", "6", …
## $ ua.patch      <chr> "1", "0-80", NA, NA, NA, NA, "2", "3", "4", "5", "1", "3", "3", "3", "4", NA, NA, "13719", "214…
## $ os.family     <chr> "Windows", "Android", "Android", "Android", "Android", "Android", "Android", "Android", "Androi…
## $ device.family <chr> "Other", "Kindle", "Kindle Fire HD", "Kindle Fire", "Kindle Fire HD", "Kindle Fire HD", "HTC De…
## $ device.brand  <chr> NA, "Amazon", "Amazon", "Amazon", "Amazon", "Amazon", "HTC", "HTC", "Amazon", "Tecno", "Samsung…
## $ device.model  <chr> NA, "Kindle", "Kindle Fire HD 7\"", "Kindle Fire", "Kindle Fire HD 7\"", "Kindle Fire HD 7\"", …
## $ os.major      <chr> NA, NA, NA, NA, NA, "4", "2", "2", "2", "2", "3", "4", "4", "4", "4", "7", "7", "XP", "8", "4",…
## $ os.minor      <chr> NA, NA, NA, NA, NA, "0", "2", "3", "3", "3", "0", "0", "0", "0", "0", NA, NA, NA, NA, "1", "0",…
## $ os.patch      <chr> NA, NA, NA, NA, NA, "3", "2", "3", "4", "5", "1", "3", "3", "3", "4", NA, NA, NA, NA, "1", "6",…
## $ os.patchMinor <chr> NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,…

set.seed(100)
batch_100 <- sample(agents, 100)
microbenchmark::microbenchmark(
  ua_parse(batch_100)
)
## Unit: milliseconds
##                 expr      min       lq     mean   median       uq      max neval
##  ua_parse(batch_100) 708.7338 721.5558 737.8894 730.8626 742.9891 928.1393   100
```

![License](https://img.shields.io/badge/License-Apache-blue.svg)

# uaparserjs

Parse ‘User-Agent’ Strings

## Description

Despite there being a section in RFC 7231
<https://datatracker.ietf.org/doc/html/rfc7231#section-5.5.3> defining a suggested
structure for ‘User-Agent’ headers this data is notoriously difficult to
parse consistently. Tools are provided that will take in user agent
strings and return structured R objects. This is a ‘V8’-backed package
based on the ‘ua-parser’ project <https://github.com/ua-parser>.

NOTE: there is a [C++-backed R
package](https://github.com/ua-parser/uap-r) but it has
[issues](https://github.com/ua-parser/uap-r/issues) compiling on a few
platforms and is dependent upon Boost regex. This version is definitely
slower but it works on all platforms.

## What’s Inside The Tin

The following functions are implemented:

  - `ua_parse`: Parse a vector of user agents into a data frame

## Installation

``` r
install.packages("uaparserjs")
```

### Usage

``` r
library(uaparserjs)

# current version
packageVersion("uaparserjs")
## [1] '0.3.5'

dplyr::glimpse(ua_parse("Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.2 (KHTML, like Gecko) Ubuntu/11.10 Chromium/15.0.874.106 Chrome/15.0.874.106 Safari/535.2"))
## Rows: 1
## Columns: 9
## $ userAgent     <chr> "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.2 (KHTML, like Gecko) Ubuntu/11.10 Chromium/15…
## $ ua.family     <chr> "Chromium"
## $ ua.major      <chr> "15"
## $ ua.minor      <chr> "0"
## $ ua.patch      <chr> "874"
## $ os.family     <chr> "Ubuntu"
## $ os.major      <chr> "11"
## $ os.minor      <chr> "10"
## $ device.family <chr> "Other"

agents <- readLines(system.file("extdat", "agents.txt", package = "uaparserjs"))

dplyr::glimpse(ua_parse(agents))
## Rows: 1,091
## Columns: 13
## $ userAgent     <chr> "Mozilla/5.0 (Windows; U; en-US) AppleWebKit/531.9 (KHTML, like Gecko) AdobeAIR/2.5.1", "Mozill…
## $ ua.family     <chr> "AdobeAIR", "Amazon Silk", "Amazon Silk", "Amazon Silk", "Amazon Silk", "Amazon Silk", "Android…
## $ ua.major      <chr> "2", "1", "2", "2", "2", "3", "2", "2", "2", "2", "3", "4", "4", "4", "4", "1", "1", "6", "7", …
## $ ua.minor      <chr> "5", "1", "0", "1", "2", "25", "2", "3", "3", "3", "0", "0", "0", "0", "0", NA, NA, "13", "6", …
## $ ua.patch      <chr> "1", "0-80", NA, NA, NA, NA, "2", "3", "4", "5", "1", "3", "3", "3", "4", NA, NA, "13719", "214…
## $ os.family     <chr> "Windows", "Android", "Android", "Android", "Android", "Android", "Android", "Android", "Androi…
## $ device.family <chr> "Other", "Kindle", "Kindle Fire HD", "Kindle Fire", "Kindle Fire HD", "Kindle Fire HD", "HTC De…
## $ device.brand  <chr> NA, "Amazon", "Amazon", "Amazon", "Amazon", "Amazon", "HTC", "HTC", "Amazon", "Tecno", "Samsung…
## $ device.model  <chr> NA, "Kindle", "Kindle Fire HD 7\"", "Kindle Fire", "Kindle Fire HD 7\"", "Kindle Fire HD 7\"", …
## $ os.major      <chr> NA, NA, NA, NA, NA, "4", "2", "2", "2", "2", "3", "4", "4", "4", "4", "7", "7", "XP", "8", "4",…
## $ os.minor      <chr> NA, NA, NA, NA, NA, "0", "2", "3", "3", "3", "0", "0", "0", "0", "0", NA, NA, NA, NA, "1", "0",…
## $ os.patch      <chr> NA, NA, NA, NA, NA, "3", "2", "3", "4", "5", "1", "3", "3", "3", "4", NA, NA, NA, NA, "1", "6",…
## $ os.patchMinor <chr> NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,…

set.seed(100)
batch_100 <- sample(agents, 100)
microbenchmark::microbenchmark(
  ua_parse(batch_100)
)
## Unit: milliseconds
##                 expr      min       lq     mean   median       uq      max neval
##  ua_parse(batch_100) 708.7338 721.5558 737.8894 730.8626 742.9891 928.1393   100
```

#    Copyright 2026 Greg Hunt

#    Licensed under the Apache License, Version 2.0 (the "License");
#    you may not use this file except in compliance with the License.
#    You may obtain a copy of the License at

#        http://www.apache.org/licenses/LICENSE-2.0

#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS,
#    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#    See the License for the specific language governing permissions and
#    limitations under the License.

library(yaml)
library(tinytest)
library(uaparserjs)

# ported from the javascript uap-core tests

#['../test_resources/firefox_user_agent_strings.yaml', '../tests/test_ua.yaml', '../test_resources/pgts_browser_list.yaml',
#  '../test_resources/opera_mini_user_agent_strings.yaml','../test_resources/podcasting_user_agent_strings.yaml'].forEach(function(fileName) {
#  var fixtures = readYAML(fileName).test_cases;
#  suite(fileName, function() {
#    fixtures.forEach(function(f) {
#      test(f.user_agent_string, function() {
#        var ua = refImpl.parse(f.user_agent_string).ua;
#        fixFixture(f, ['major', 'minor', 'patch']);
#        assert.strictEqual(ua.family, f.family, msg('ua.family', ua.family, f.family));
#         assert.strictEqual(ua.major, f.major, msg('ua.major', ua.major, f.major));
#         assert.strictEqual(ua.minor, f.minor, msg('ua.minor', ua.minor, f.minor));
#         assert.strictEqual(ua.patch, f.patch, msg('ua.patch', ua.patch, f.patch));
#       });
#     });
#   });
# });

uaTest<-function()
{
  uaFiles = c('./tests/test_ua.yaml')

  for(fName in uaFiles )
  {
    uas = read_yaml(fName)
    for(ua in uas$test_cases)
    {
      thisUa = uaparserjs::ua_parse(ua$user_agent_string)
      expect_equal(thisUa$ua.family, ua$family);
      expect_equal(thisUa$ua.major, ua$major);
      expect_equal(thisUa$ua.minor, ua$minor);
      expect_equal(thisUa$ua.patch, ua$patch);
    }
  }
}

uaTest()

# ['../tests/test_os.yaml', '../test_resources/additional_os_tests.yaml'].forEach(function(fileName) {
#   var fixtures = readYAML(fileName).test_cases;
#   suite(fileName, function() {
#     fixtures.forEach(function(f) {
#       test(f.user_agent_string, function() {
#         var os = refImpl.parse(f.user_agent_string).os;
#         fixFixture(f, ['major', 'minor', 'patch', 'patch_minor']);
#         assert.strictEqual(os.family, f.family, msg('os.family', os.family, f.family));
#         assert.strictEqual(os.major, f.major, msg('os.major', os.major, f.major));
#         assert.strictEqual(os.minor, f.minor, msg('os.minor', os.minor, f.minor));
#         assert.strictEqual(os.patch, f.patch, msg('os.patch', os.patch, f.patch));
#         assert.strictEqual(os.patchMinor, f.patch_minor, msg('os.patchMinor', os.patchMinor, f.patch_minor));
#       });
#     });
#   });
# });

osTest<-function()
{
  uaFiles = c("./tests/test_os.yaml")

  for(fName in uaFiles )
  {
    uas = read_yaml(fName)
    for(os in uas$test_cases)
    {
      thisUa = uaparserjs::ua_parse(os$user_agent_string)
      expect_equal(thisUa$os.family, os$family);
      expect_equal(thisUa$os.major, os$major);
      expect_equal(thisUa$os.minor, os$minor);
      expect_equal(thisUa$os.patch, os$patch);
    }
  }
}

osTest()


# ['../tests/test_device.yaml'].forEach(function(fileName) {
#   var fixtures = readYAML(fileName).test_cases;
#   suite(fileName, function() {
#     fixtures.forEach(function(f) {
#       test(f.user_agent_string, function() {
#         var device = refImpl.parse(f.user_agent_string).device;
#         fixFixture(f, ['family', 'brand', 'model']);
#         assert.strictEqual(device.family, f.family, msg('device.family', device.family, f.family));
#         assert.strictEqual(device.brand, f.brand, msg('device.brand', device.brand, f.brand));
#         assert.strictEqual(device.model, f.model, msg('device.model', device.model, f.model));
#       });
#     });
#   });
# });

devTest<-function()
{
  uaFiles = c("./tests/test_device.yaml")

  for(fName in uaFiles )
  {
    uas = read_yaml(fName)
    for(dev in uas$test_cases)
    {
      thisUa = uaparserjs::ua_parse(dev$user_agent_string)
      expect_equal(thisUa$device.family, dev$family);
      expect_equal(thisUa$device.brand, dev$brand);
      expect_equal(thisUa$device.model, dev$model);
    }
  }
}

devTest()

#function fixFixture(f, props) {
#  // A bug in the YAML parser makes empty fixture props
#  // return a vanila object.
#  props.forEach(function(p) {
#    if (typeof f[p] === 'object') {
#      f[p] = null;
#    }
#  })
#  return f;
#}

#    Copyright 2026 Greg Hunt

#    Licensed under the Apache License, Version 2.0 (the "License");
#    you may not use this file except in compliance with the License.
#    You may obtain a copy of the License at

#        http://www.apache.org/licenses/LICENSE-2.0

#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS,
#    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#    See the License for the specific language governing permissions and
#    limitations under the License.

library(yaml)
library(tinytest)
library(uaparserjs)

# ported from the javascript uap-core tests

#['../test_resources/firefox_user_agent_strings.yaml', '../tests/test_ua.yaml', '../test_resources/pgts_browser_list.yaml',
#  '../test_resources/opera_mini_user_agent_strings.yaml','../test_resources/podcasting_user_agent_strings.yaml'].forEach(function(fileName) {
#  var fixtures = readYAML(fileName).test_cases;
#  suite(fileName, function() {
#    fixtures.forEach(function(f) {
#      test(f.user_agent_string, function() {
#        var ua = refImpl.parse(f.user_agent_string).ua;
#        fixFixture(f, ['major', 'minor', 'patch']);
#        assert.strictEqual(ua.family, f.family, msg('ua.family', ua.family, f.family));
#         assert.strictEqual(ua.major, f.major, msg('ua.major', ua.major, f.major));
#         assert.strictEqual(ua.minor, f.minor, msg('ua.minor', ua.minor, f.minor));
#         assert.strictEqual(ua.patch, f.patch, msg('ua.patch', ua.patch, f.patch));
#       });
#     });
#   });
# });

uaTest <- function()
{
  uaFiles = c("./tests/test_ua.yaml")

  uaparserjs:::cache_reset()

  for(fName in uaFiles)
  {
    uas = read_yaml(fName)
    for(ua in uas$test_cases)
    {
      thisUa = uaparserjs::ua_parse(ua$user_agent_string)
      expect_equal(thisUa$ua.family, ua$family)
      expect_equal(thisUa$ua.major, ua$major)
      expect_equal(thisUa$ua.minor, ua$minor)
      expect_equal(thisUa$ua.patch, ua$patch)
    }
  }
}

uaTestNA <- function()
{
  uaFiles = c("./tests/test_ua.yaml")

  #uaparserjs:::cache_reset()
  for(fName in uaFiles)
  {
    uas = read_yaml(fName)
    #uas = uaparserjs:::nullToNA(uas)
    for(ua in uas$test_cases)
    {
      thisUa = uaparserjs::ua_parse(ua$user_agent_string, useNA=TRUE)
      expect_equal(thisUa$ua.family, ua$family)
      if(is.null(ua$major))
      {
        expect_true(is.na(thisUa$ua.major))
      }
      else
      {
        expect_equal(thisUa$ua.major, ua$major)
      }
      if(is.null(ua$minor))
      {
        expect_true(is.na(thisUa$ua.minor))
      }
      else
      {
        expect_equal(thisUa$ua.minor, ua$minor)
      }
      if(is.null(ua$patch))
      {
        expect_true(is.na(thisUa$ua.patch))
      }
      else
      {
        expect_equal(thisUa$ua.patch, ua$patch)
      }
    }
  }

}


# ['../tests/test_os.yaml', '../test_resources/additional_os_tests.yaml'].forEach(function(fileName) {
#   var fixtures = readYAML(fileName).test_cases;
#   suite(fileName, function() {
#     fixtures.forEach(function(f) {
#       test(f.user_agent_string, function() {
#         var os = refImpl.parse(f.user_agent_string).os;
#         fixFixture(f, ['major', 'minor', 'patch', 'patch_minor']);
#         assert.strictEqual(os.family, f.family, msg('os.family', os.family, f.family));
#         assert.strictEqual(os.major, f.major, msg('os.major', os.major, f.major));
#         assert.strictEqual(os.minor, f.minor, msg('os.minor', os.minor, f.minor));
#         assert.strictEqual(os.patch, f.patch, msg('os.patch', os.patch, f.patch));
#         assert.strictEqual(os.patchMinor, f.patch_minor, msg('os.patchMinor', os.patchMinor, f.patch_minor));
#       });
#     });
#   });
# });

osTest <- function()
{
  uaFiles = c("./tests/test_os.yaml")

  for(fName in uaFiles)
  {
    uas = read_yaml(fName)
    for(os in uas$test_cases)
    {
      thisUa = uaparserjs::ua_parse(os$user_agent_string)
      expect_equal(thisUa$os.family, os$family)
      expect_equal(thisUa$os.major, os$major)
      expect_equal(thisUa$os.minor, os$minor)
      expect_equal(thisUa$os.patch, os$patch)
    }
  }
}


osTestNA <- function()
{
  uaFiles = c("./tests/test_os.yaml")

  for(fName in uaFiles)
  {
    uas = read_yaml(fName)
    for(os in uas$test_cases)
    {
      thisUa = uaparserjs::ua_parse(os$user_agent_string, useNA=TRUE)
      expect_equal(thisUa$os.family, os$family)
      if(is.null(os$major))
      {
        expect_true(is.na(thisUa$os.major))
      }
      else
      {
        expect_equal(thisUa$os.major, os$major)
      }
      if(is.null(os$minor))
      {
        expect_true(is.na(thisUa$os.minor))
      }
      else
      {
        expect_equal(thisUa$os.minor, os$minor)
      }
      if(is.null(os$patch))
      {
        expect_true(is.na(thisUa$os.patch))
      }
      else
      {
        expect_equal(thisUa$os.patch, os$patch, info="NA true - patch")
      }
    }
  }
}



# ['../tests/test_device.yaml'].forEach(function(fileName) {
#   var fixtures = readYAML(fileName).test_cases;
#   suite(fileName, function() {
#     fixtures.forEach(function(f) {
#       test(f.user_agent_string, function() {
#         var device = refImpl.parse(f.user_agent_string).device;
#         fixFixture(f, ['family', 'brand', 'model']);
#         assert.strictEqual(device.family, f.family, msg('device.family', device.family, f.family));
#         assert.strictEqual(device.brand, f.brand, msg('device.brand', device.brand, f.brand));
#         assert.strictEqual(device.model, f.model, msg('device.model', device.model, f.model));
#       });
#     });
#   });
# });

devTest <- function()
{
  uaFiles = c("./tests/test_device.yaml")


  for(fName in uaFiles)
  {
    uas = read_yaml(fName)
    for(dev in uas$test_cases)
    {
      thisUa = uaparserjs::ua_parse(dev$user_agent_string)
      expect_equal(thisUa$device.family, dev$family)
      expect_equal(thisUa$device.brand, dev$brand)
      expect_equal(thisUa$device.model, dev$model)
    }
  }
}

devTestNA <- function()
{
  uaFiles = c("./tests/test_device.yaml")

  for(fName in uaFiles)
  {
    uas = read_yaml(fName)
    for(dev in uas$test_cases)
    {
      thisUa = uaparserjs::ua_parse(dev$user_agent_string, useNA=TRUE)
      if(is.null(dev$family))
      {
        expect_true(is.na(thisUa$device.family))
      }
      else
      {
        expect_equal(thisUa$device.family, dev$family)
      }
      if(is.null(dev$brand))
      {
        expect_true(is.na(thisUa$device.brand))
      }
      else
      {
        expect_equal(thisUa$device.brand, dev$brand, info=paste("with NA", thisUa$device.brand, dev$brand))
      }
      if(is.null(dev$model))
      {
        expect_true(is.na(thisUa$device.model))
      }
      else
      {
        expect_equal(thisUa$device.model, dev$model)
      }
    }
  }
}


#function fixFixture(f, props) {
#  // A bug in the YAML parser makes empty fixture props
#  // return a vanila object.
#  props.forEach(function(p) {
#    if (typeof f[p] === 'object') {
#      f[p] = null;
#    }
#  })
#  return f;
#}

# check for local dev environment - this is unreliable 
# but better than the complete absence of support for detecting 
# a CRAN build from the R team   

if(dir.exists("../../../.git"))
{  
  uaTest()
  uaTestNA()

  osTest()
  osTestNA()

  devTest()
  devTestNA()
}

#    Copyright 2020 Bob Rudis
#    Copyright 2026 Greg Hunt

#    Licensed under the Apache License, Version 2.0 (the "License");
#    you may not use this file except in compliance with the License.
#    You may obtain a copy of the License at

#        http://www.apache.org/licenses/LICENSE-2.0

#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS,
#    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#    See the License for the specific language governing permissions and
#    limitations under the License.

library(uaparserjs)
library(tinytest)

# Placeholder with simple test
res <- ua_parse(paste0("Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.2 (KHTML, ",
                       "like Gecko) Ubuntu/11.10 Chromium/15.0.874.106 ",
                       "Chrome/15.0.874.106 Safari/535.2", collapse=""))

expect_true(inherits(res, "data.frame"))
expect_equal(res$ua.patch, "874")
expect_equal(res$os.family, "Ubuntu")
expect_equal(res$ua.family, "Chromium")
expect_equal(res$ua.major, "15")
expect_equal(res$ua.minor, "0")
expect_equal(res$ua.patch, "874")
expect_equal(res$os.major, "11")
expect_equal(res$os.minor, "10")
expect_equal(res$device.family, "Other")

#    Copyright 2026 Greg Hunt

#    Licensed under the Apache License, Version 2.0 (the "License");
#    you may not use this file except in compliance with the License.
#    You may obtain a copy of the License at

#        http://www.apache.org/licenses/LICENSE-2.0

#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS,
#    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#    See the License for the specific language governing permissions and
#    limitations under the License.

library(yaml)
library(tinytest)
library(uaparserjs)

uas_test <- data.frame(
  label = LETTERS[1:6],
  uastrings = c(
    paste0("Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.2 (KHTML, ",
           "like Gecko) Ubuntu/11.10 Chromium/15.0.874.106 ",
           "Chrome/15.0.874.106 Safari/535.2",
           collapse=""),
    "",
    paste0("Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 ",
           "(KHTML, like Gecko) Chrome/90.0.4430.212 Safari/537.36",
           collapse=""),
    NA_character_,
    paste0("Mozilla/5.0 (Linux; Android 9; moto g(6)) AppleWebKit/537.36 ",
           "(KHTML, like Gecko) Chrome/90.0.4430.210 Mobile Safari/537.36",
           collapse=""),
    " "

  ))

res = uaparserjs::ua_parse(uas_test$uastrings)

# dumped output from old code for comparison
oldres <-structure(list(userAgent =
c("Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.2 (KHTML, like Gecko) Ubuntu/11.10 Chromium/15.0.874.106 Chrome/15.0.874.106 Safari/535.2",
"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.212 Safari/537.36",
"Mozilla/5.0 (Linux; Android 9; moto g(6)) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.210 Mobile Safari/537.36",
" "), ua.family = c("Chromium", "Chrome", "Chrome Mobile", "Other"
), ua.major = c("15", "90", "90", NA), ua.minor = c("0", "0",
"0", NA), ua.patch = c("874", "4430", "4430", NA), os.family = c("Ubuntu",
"Windows", "Android", "Other"), os.major = c("11", "10", "9",
NA), os.minor = c("10", NA, NA, NA), device.family = c("Other",
"Other", "Motorola g(6)", "Other"), device.brand = c(NA, NA,
"Motorola", NA), device.model = c(NA, NA, "g(6)", NA)), row.names = c(NA,
-4L), class = c("tbl_df", "tbl", "data.frame"))

expect_equal(nrow(res), 4, info="useNA FALSE in multi-row check")
expect_equal(res, oldres, info="useNA FALSE in multi-row check")

res = uaparserjs::ua_parse(uas_test$uastrings, useNA = TRUE)

# dumped output from useNA code
NAres <-
structure(list(userAgent = c("Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.2 (KHTML, like Gecko) Ubuntu/11.10 Chromium/15.0.874.106 Chrome/15.0.874.106 Safari/535.2",
"", "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.212 Safari/537.36",
NA, "Mozilla/5.0 (Linux; Android 9; moto g(6)) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.210 Mobile Safari/537.36",
" "), ua.family = c("Chromium", "Other", "Chrome", "Other", "Chrome Mobile",
"Other"), ua.major = c("15", NA, "90", NA, "90", NA), ua.minor = c("0",
NA, "0", NA, "0", NA), ua.patch = c("874", NA, "4430", NA, "4430",
NA), os.family = c("Ubuntu", "Other", "Windows", "Other", "Android",
"Other"), os.major = c("11", NA, "10", NA, "9", NA), os.minor = c("10",
NA, NA, NA, NA, NA), os.patch = c(NA_character_, NA_character_,
NA_character_, NA_character_, NA_character_, NA_character_),
    os.patchMinor = c(NA_character_, NA_character_, NA_character_,
    NA_character_, NA_character_, NA_character_), device.family = c("Other",
    "Other", "Other", "Other", "Motorola g(6)", "Other"), device.brand = c(NA,
    NA, NA, NA, "Motorola", NA), device.model = c(NA, NA, NA,
    NA, "g(6)", NA)), class = c("tbl_df", "tbl", "data.frame"
), row.names = c(NA, -6L))

expect_equal(nrow(res), 6, info="useNA TRUE in multi-row check")
expect_equal(res, NAres, info="useNA TRUE in multi-row check")

# permutation code copied from https://stackoverflow.com/questions/11095992/generating-all-distinct-permutations-of-a-list-in-r
# under CC SA license
#

getPermutations <- function(x) {
    if (length(x) == 1) {
        return(x)
    }
    else {
        res <- matrix(nrow = 0, ncol = length(x))
        for (i in seq_along(x)) {
            res <- rbind(res, cbind(x[i], Recall(x[-i])))
        }
        return(res)
    }
}

permutations = unique(getPermutations(list("", "", " ", " ", NA, NA, "aaa", paste0("Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.2 (KHTML, ",
           "like Gecko) Ubuntu/11.10 Chromium/15.0.874.106 ",
           "Chrome/15.0.874.106 Safari/535.2",
           collapse=""))))

templateResult = list()

# collect results from first row
for(p in permutations[1,])
{
    templateResult[deparse(p)] = list(tibble::as_tibble(uaparserjs::ua_parse(p, useNA=TRUE)))
}

# number of rows
numPerms = dim(permutations)[1]

# for each combination
for(i in 1:numPerms)
{
    res = uaparserjs::ua_parse(unlist(permutations[i,]), useNA=TRUE)
    for(j in seq_along(length(res)))
    {
       expect_equal(res[j,], templateResult[[deparse(unlist(permutations[i,j]))]], info=permutations[i,j])
    }
}

#    Copyright 2020 Bob Rudis
#    Copyright 2026 Greg Hunt

#    Licensed under the Apache License, Version 2.0 (the "License");
#    you may not use this file except in compliance with the License.
#    You may obtain a copy of the License at

#        http://www.apache.org/licenses/LICENSE-2.0

#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS,
#    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#    See the License for the specific language governing permissions and
#    limitations under the License.

library(uaparserjs)
library(tinytest)

# Placeholder with simple test
res <- ua_parse(paste0("Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.2 (KHTML, ",
                       "like Gecko) Ubuntu/11.10 Chromium/15.0.874.106 ",
                       "Chrome/15.0.874.106 Safari/535.2", collapse=""))

# smoke test
expect_true(inherits(res, "data.frame"))
expect_equal(res$ua.patch, "874")
expect_equal(res$os.family, "Ubuntu")
expect_equal(res$ua.family, "Chromium")
expect_equal(res$ua.major, "15")
expect_equal(res$ua.minor, "0")
expect_equal(res$ua.patch, "874")
expect_equal(res$os.major, "11")
expect_equal(res$os.minor, "10")
expect_equal(res$device.family, "Other")

# existing behaviour
res <- uaparserjs::ua_parse("", useNA=FALSE)
expect_true(nrow(res) == 0, info="0 character string parameter")
res <- uaparserjs::ua_parse(" ", useNA=FALSE)
expect_true(length(names(res)) == 4)
res <- uaparserjs::ua_parse(NULL, useNA=FALSE)
expect_true(nrow(res) == 0, info="NULL parameter")

# new behaviour
res <- uaparserjs::ua_parse(" ", useNA=TRUE)
expect_equal(res$userAgent, " ")
expect_true(is.na(res$ua.patch))
expect_equal(res$os.family, "Other")
expect_equal(res$ua.family, "Other")
expect_true(is.na(res$ua.major))
expect_true(is.na(res$ua.minor))
expect_true(is.na(res$ua.patch))
expect_true(is.na(res$os.major))
expect_true(is.na(res$os.minor))
expect_equal(res$device.family, "Other")

res <- uaparserjs::ua_parse(list(" "), useNA=TRUE)
expect_equal(res$userAgent, " ")
expect_true(is.na(res$ua.patch))
expect_equal(res$os.family, "Other")
expect_equal(res$ua.family, "Other")
expect_true(is.na(res$ua.major))
expect_true(is.na(res$ua.minor))
expect_true(is.na(res$ua.patch))
expect_true(is.na(res$os.major))
expect_true(is.na(res$os.minor))
expect_equal(res$device.family, "Other")

res <- uaparserjs::ua_parse("", useNA=TRUE)
expect_equal(res$userAgent, "")
expect_true(is.na(res$ua.patch))
expect_equal(res$os.family, "Other")
expect_equal(res$ua.family, "Other")
expect_true(is.na(res$ua.major))
expect_true(is.na(res$ua.minor))
expect_true(is.na(res$ua.patch))
expect_true(is.na(res$os.major))
expect_true(is.na(res$os.minor))
expect_equal(res$device.family, "Other")

res <- uaparserjs::ua_parse(list(""), useNA=TRUE)
expect_equal(res$userAgent, "")
expect_true(is.na(res$ua.patch))
expect_equal(res$os.family, "Other")
expect_equal(res$ua.family, "Other")
expect_true(is.na(res$ua.major))
expect_true(is.na(res$ua.minor))
expect_true(is.na(res$ua.patch))
expect_true(is.na(res$os.major))
expect_true(is.na(res$os.minor))
expect_equal(res$device.family, "Other")

res <- uaparserjs::ua_parse(NULL, useNA=TRUE)
expect_true(is.na(res$userAgent))
expect_true(is.na(res$ua.patch))
expect_equal(res$os.family, "Other")
expect_equal(res$ua.family, "Other")
expect_true(is.na(res$ua.major))
expect_true(is.na(res$ua.minor))
expect_true(is.na(res$ua.patch))
expect_true(is.na(res$os.major))
expect_true(is.na(res$os.minor))
expect_equal(res$device.family, "Other")

# check cache does not return wrong values as well as checking null return values
res <- uaparserjs::ua_parse(NULL, useNA=FALSE)
expect_true(!("userAgent" %in% names(res)))
expect_true(!("os.patch" %in% names(res)))
expect_true(!("osfamily" %in% names(res)))
expect_true(!("ua.family" %in% names(res)))
expect_true(!("ua.major" %in% names(res)))
expect_true(!("ua.minor" %in% names(res)))
expect_true(!("ua.patch" %in% names(res)))
expect_true(!("os.major" %in% names(res)))
expect_true(!("os.minor" %in% names(res)))
expect_true(!("device.family" %in% names(res)))

res <- uaparserjs::ua_parse(list(NULL), useNA=TRUE)
expect_true(is.na(res$userAgent))
expect_true(is.na(res$ua.patch))
expect_equal(res$os.family, "Other")
expect_equal(res$ua.family, "Other")
expect_true(is.na(res$ua.major))
expect_true(is.na(res$ua.minor))
expect_true(is.na(res$ua.patch))
expect_true(is.na(res$os.major))
expect_true(is.na(res$os.minor))
expect_equal(res$device.family, "Other")

res <- uaparserjs::ua_parse(NA, useNA=TRUE)
expect_true(is.na(res$userAgent))
expect_true(is.na(res$ua.patch))
expect_equal(res$os.family, "Other")
expect_equal(res$ua.family, "Other")
expect_true(is.na(res$ua.major))
expect_true(is.na(res$ua.minor))
expect_true(is.na(res$ua.patch))
expect_true(is.na(res$os.major))
expect_true(is.na(res$os.minor))
expect_equal(res$device.family, "Other")

res <- uaparserjs::ua_parse(list(NA), useNA=TRUE)
expect_true(is.na(res$userAgent))
expect_true(is.na(res$ua.patch))
expect_equal(res$os.family, "Other")
expect_equal(res$ua.family, "Other")
expect_true(is.na(res$ua.major))
expect_true(is.na(res$ua.minor))
expect_true(is.na(res$ua.patch))
expect_true(is.na(res$os.major))
expect_true(is.na(res$os.minor))
expect_equal(res$device.family, "Other")
